Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/MoveEvaluators/TwoOpt/TSPInversionMoveEvaluator.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/MoveEvaluators/TwoOpt/TSPInversionMoveEvaluator.cs	(revision 17241)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/MoveEvaluators/TwoOpt/TSPInversionMoveEvaluator.cs	(revision 17241)
@@ -0,0 +1,52 @@
+﻿using HEAL.Attic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PermutationEncoding;
+using HeuristicLab.Parameters;
+
+namespace HeuristicLab.Problems.TravelingSalesman {
+  [Item("TSP Inversion Move Evaluator", "Evaluates the quality of an inversion move based on an efficient delta computation.")]
+  [StorableType("74ac2d20-2371-4f4c-8796-1f318d1b33c0")]
+  public class TSPInversionMoveEvaluator : TSPMoveEvaluator, IPermutationInversionMoveOperator {
+    [Storable] public ILookupParameter<InversionMove> MoveParameter { get; private set; }
+
+    ILookupParameter<InversionMove> IPermutationInversionMoveOperator.InversionMoveParameter => MoveParameter;
+    ILookupParameter<Permutation> IPermutationMoveOperator.PermutationParameter => TSPTourParameter;
+
+    [StorableConstructor]
+    protected TSPInversionMoveEvaluator(StorableConstructorFlag _) : base(_) { }
+    protected TSPInversionMoveEvaluator(TSPInversionMoveEvaluator original, Cloner cloner)
+      : base(original, cloner) {
+      MoveParameter = cloner.Clone(original.MoveParameter);
+    }
+    public TSPInversionMoveEvaluator()
+      : base() {
+      Parameters.Add(MoveParameter = new LookupParameter<InversionMove>("Move", "The inversion move that is to be evaluated."));
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new TSPInversionMoveEvaluator(this, cloner);
+    }
+
+    protected override double CalculateTourLengthWithMove(ITSPData tspData, Permutation tspTour, double tourLength) {
+      var move = MoveParameter.ActualValue;
+      return CalculateTourLengthDelta(tspData, tspTour, move);
+    }
+
+    public static double CalculateTourLengthDelta(ITSPData tspData, Permutation tspTour, InversionMove move) {
+      int edge1source = tspTour.GetCircular(move.Index1 - 1);
+      int edge1target = tspTour[move.Index1];
+      int edge2source = tspTour[move.Index2];
+      int edge2target = tspTour.GetCircular(move.Index2 + 1);
+      if (move.Index2 - move.Index1 >= tspTour.Length - 2) return 0;
+      double moveQuality = 0;
+      // remove two edges
+      moveQuality -= tspData.GetDistance(edge1source, edge1target);
+      moveQuality -= tspData.GetDistance(edge2source, edge2target);
+      // add two edges
+      moveQuality += tspData.GetDistance(edge1source, edge2source);
+      moveQuality += tspData.GetDistance(edge1target, edge2target);
+      return moveQuality;
+    }
+  }
+}
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/PathRelinkers/TSPMultipleGuidesPathRelinker.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/PathRelinkers/TSPMultipleGuidesPathRelinker.cs	(revision 17240)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/PathRelinkers/TSPMultipleGuidesPathRelinker.cs	(revision 17241)
@@ -23,4 +23,5 @@
 using System.Collections.Generic;
 using System.Linq;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -29,5 +30,4 @@
 using HeuristicLab.Optimization.Operators;
 using HeuristicLab.Parameters;
-using HEAL.Attic;
 
 namespace HeuristicLab.Problems.TravelingSalesman {
@@ -39,26 +39,17 @@
   /// </remarks>
   [Item("TSPMultipleGuidesPathRelinker", "An operator that relinks paths between traveling salesman solutions using a multiple guiding strategy. The operator incrementally changes the initiating solution towards the guiding solution by correcting edges as needed. For each city it choses the best edge from all guiding solutions.")]
-  [StorableType("6B5B2622-AB1D-47E6-8BBC-C6088D393149")]
+  [StorableType("13e879fd-7621-402e-9345-7dbfdd78e3b6")]
   public sealed class TSPMultipleGuidesPathRelinker : SingleObjectivePathRelinker {
-    #region Parameter properties
-    public ILookupParameter<DistanceMatrix> DistanceMatrixParameter {
-      get { return (ILookupParameter<DistanceMatrix>)Parameters["DistanceMatrix"]; }
-    }
-    #endregion
-
-    #region Properties
-    public DistanceMatrix DistanceMatrix {
-      get { return DistanceMatrixParameter.ActualValue; }
-    }
-    #endregion
+    [Storable] public ILookupParameter<ITSPData> TSPDataParameter { get; private set; }
 
     [StorableConstructor]
     private TSPMultipleGuidesPathRelinker(StorableConstructorFlag _) : base(_) { }
-    private TSPMultipleGuidesPathRelinker(TSPMultipleGuidesPathRelinker original, Cloner cloner) : base(original, cloner) { }
+    private TSPMultipleGuidesPathRelinker(TSPMultipleGuidesPathRelinker original, Cloner cloner)
+      : base(original, cloner) {
+      TSPDataParameter = cloner.Clone(original.TSPDataParameter);
+    }
     public TSPMultipleGuidesPathRelinker()
       : base() {
-      #region Create parameters
-      Parameters.Add(new LookupParameter<DistanceMatrix>("DistanceMatrix", "The matrix which contains the distances between the cities."));
-      #endregion
+      Parameters.Add(TSPDataParameter = new LookupParameter<ITSPData>("TSPData", "The main parameters of the TSP."));
     }
 
@@ -67,5 +58,5 @@
     }
 
-    public static ItemArray<IItem> Apply(IItem initiator, IItem[] guides, DistanceMatrix distances, PercentValue n) {
+    public static ItemArray<IItem> Apply(IItem initiator, IItem[] guides, ITSPData tspData, PercentValue n) {
       if (!(initiator is Permutation) || guides.Any(x => !(x is Permutation)))
         throw new ArgumentException("Cannot relink path because some of the provided solutions have the wrong type.");
@@ -84,5 +75,5 @@
         int currCityIndex = i;
         int bestCityIndex = (i + 1) % v1.Length;
-        double currDistance = distances[v1[currCityIndex], v1[bestCityIndex]];
+        double currDistance = tspData.GetDistance(v1[currCityIndex], v1[bestCityIndex]);
         // check each guiding solution
         targets.ToList().ForEach(solution => {
@@ -92,5 +83,5 @@
           int succ = solution[(node.Index + 1) % solution.Length];
           // get distances to neighbors
-          var results = new[] { pred, succ }.Select(x => new { Id = x, Distance = distances[x, node.Id] });
+          var results = new[] { pred, succ }.Select(x => new { Id = x, Distance = tspData.GetDistance(x, node.Id) });
           var bestCity = results.Where(x => x.Distance < currDistance).OrderBy(x => x.Distance).FirstOrDefault();
           if (bestCity != null) {
@@ -129,5 +120,5 @@
       if (parents.Length < 2)
         throw new ArgumentException("The number of parents is smaller than 2.");
-      return Apply(parents[0], parents.Skip(1).ToArray(), DistanceMatrix, n);
+      return Apply(parents[0], parents.Skip(1).ToArray(), TSPDataParameter.ActualValue, n);
     }
   }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/PathRelinkers/TSPPathRelinker.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/PathRelinkers/TSPPathRelinker.cs	(revision 17240)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/PathRelinkers/TSPPathRelinker.cs	(revision 17241)
@@ -23,4 +23,5 @@
 using System.Collections.Generic;
 using System.Linq;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -28,7 +29,7 @@
 using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Optimization.Operators;
-using HEAL.Attic;
 
 namespace HeuristicLab.Problems.TravelingSalesman {
+
   /// <summary>
   /// An operator that relinks paths between traveling salesman solutions.
@@ -38,5 +39,5 @@
   /// </remarks>
   [Item("TSPPathRelinker", "An operator that relinks paths between traveling salesman solutions. The operator incrementally assimilates the initiating solution into the guiding solution by correcting edges as needed.")]
-  [StorableType("0997A24C-0592-4CE4-A681-70C97890D3F7")]
+  [StorableType("a2c5de50-a050-4269-b80e-1c995eb51626")]
   public sealed class TSPPathRelinker : SingleObjectivePathRelinker {
     [StorableConstructor]
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/PathRelinkers/TSPSimultaneousPathRelinker.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/PathRelinkers/TSPSimultaneousPathRelinker.cs	(revision 17240)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/PathRelinkers/TSPSimultaneousPathRelinker.cs	(revision 17241)
@@ -23,4 +23,5 @@
 using System.Collections.Generic;
 using System.Linq;
+using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
@@ -28,5 +29,4 @@
 using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Optimization.Operators;
-using HEAL.Attic;
 
 namespace HeuristicLab.Problems.TravelingSalesman {
@@ -38,5 +38,5 @@
   /// </remarks>
   [Item("TSPSimultaneousPathRelinker", "An operator that relinks paths between traveling salesman solutions starting from both ends. The operator incrementally assimilates the initiating solution into the guiding solution and vice versa by correcting edges as needed.")]
-  [StorableType("D44D112E-5139-4848-8A2B-66CFC5784EE4")]
+  [StorableType("73457ec0-1d71-4d9f-b646-2ba3639317e2")]
   public sealed class TSPSimultaneousPathRelinker : SingleObjectivePathRelinker {
     [StorableConstructor]
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/TSP.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/TSP.cs	(revision 17240)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/TSP.cs	(revision 17241)
@@ -1,3 +1,4 @@
 ﻿using System;
+using System.Linq;
 using HEAL.Attic;
 using HeuristicLab.Common;
@@ -6,4 +7,6 @@
 using HeuristicLab.Encodings.PermutationEncoding;
 using HeuristicLab.Optimization;
+using HeuristicLab.Parameters;
+using HeuristicLab.PluginInfrastructure;
 using HeuristicLab.Problems.Instances;
 
@@ -11,28 +14,24 @@
   [Item("Traveling Salesman Problem (TSP)", "Represents a symmetric Traveling Salesman Problem.")]
   [Creatable(CreatableAttribute.Categories.CombinatorialProblems, Priority = 100)]
-  [StorableType("60511a03-b8b4-47cd-a119-78f97358a6b0")]
-  public class TSP : SingleObjectiveProblem<PermutationEncoding, Permutation>, IProblemInstanceConsumer<TSPData> {
+  [StorableType("8415476a-69de-45ad-95be-298ed7c97e84")]
+  public class TSP : PermutationProblem, IProblemInstanceConsumer<TSPData> {
+    /// <summary>
+    /// This limit governs when a distance matrix is used. For all problems smaller than that, the distance matrix is
+    /// computed. This greatly speeds up computation time.
+    /// </summary>
     public static int DistanceMatrixSizeLimit { get; set; } = 1000;
 
     public override bool Maximization => false;
 
-    [Storable]
-    private IValueParameter<ITSPData> tspDataParameter;
-    public IValueParameter<ITSPData> TSPDataParameter {
-      get { return tspDataParameter; }
-    }
-    [Storable]
-    private IValueParameter<Permutation> bestKnownSolutionParameter;
-    public IValueParameter<Permutation> BestKnownSolutionParameter {
-      get { return bestKnownSolutionParameter; }
-    }
+    [Storable] public IValueParameter<ITSPData> TSPDataParameter { get; private set; }
+    [Storable] public IValueParameter<Permutation> BestKnownSolutionParameter { get; private set; }
 
     public ITSPData TSPData {
-      get { return tspDataParameter.Value; }
-      set { tspDataParameter.Value = value; }
+      get { return TSPDataParameter.Value; }
+      set { TSPDataParameter.Value = value; }
     }
     public Permutation BestKnownSolution {
-      get { return bestKnownSolutionParameter.Value; }
-      set { bestKnownSolutionParameter.Value = value; }
+      get { return BestKnownSolutionParameter.Value; }
+      set { BestKnownSolutionParameter.Value = value; }
     }
 
@@ -42,10 +41,13 @@
     protected TSP(TSP original, Cloner cloner)
       : base(original, cloner) {
-      tspDataParameter = cloner.Clone(original.tspDataParameter);
-      bestKnownSolutionParameter = cloner.Clone(original.bestKnownSolutionParameter);
+      TSPDataParameter = cloner.Clone(original.TSPDataParameter);
+      BestKnownSolutionParameter = cloner.Clone(original.BestKnownSolutionParameter);
     }
 
     public TSP() : base(new PermutationEncoding("Tour", 16, PermutationTypes.RelativeUndirected)) {
-      TSPData = new RoundedEuclideanCoordinatesTSPData() {
+      Parameters.Add(TSPDataParameter = new ValueParameter<ITSPData>("TSPData", "The main parameters of the TSP."));
+      Parameters.Add(BestKnownSolutionParameter = new OptionalValueParameter<Permutation>("BestKnownSolution", "The best known solution."));
+      
+      TSPData = new EuclideanTSPData() {
         Coordinates = new DoubleMatrix(new double[,] {
         { 100, 100 }, { 100, 200 }, { 100, 300 }, { 100, 400 },
@@ -53,6 +55,9 @@
         { 300, 100 }, { 300, 200 }, { 300, 300 }, { 300, 400 },
         { 400, 100 }, { 400, 200 }, { 400, 300 }, { 400, 400 }
-        })
+        }),
+        Rounding = EuclideanTSPData.RoundingMode.Midpoint
       };
+
+      InitializeOperators();
     }
 
@@ -72,4 +77,22 @@
       tourLength += TSPData.GetDistance(tour[tour.Length - 1], tour[0]);
       return tourLength;
+    }
+
+    public override void Analyze(Permutation[] solutions, double[] qualities, ResultCollection results, IRandom random) {
+      base.Analyze(solutions, qualities, results, random);
+      int i = -1;
+      if (!Maximization)
+        i = qualities.Select((x, index) => new { index, Fitness = x }).OrderBy(x => x.Fitness).First().index;
+      else i = qualities.Select((x, index) => new { index, Fitness = x }).OrderByDescending(x => x.Fitness).First().index;
+
+      if (double.IsNaN(BestKnownQuality) ||
+          Maximization && qualities[i] > BestKnownQuality ||
+          !Maximization && qualities[i] < BestKnownQuality) {
+        BestKnownQualityParameter.ActualValue = new DoubleValue(qualities[i]);
+        BestKnownSolutionParameter.ActualValue = (Permutation)solutions[i].Clone();
+      }
+
+      var solution = TSPData.GetSolution(solutions[i], qualities[i]);
+      results.AddOrUpdateResult("Best TSP Solution", solution);
     }
 
@@ -84,4 +107,5 @@
         throw new System.IO.InvalidDataException("The coordinates of the given instance are not in the right format, there need to be one row for each customer and two columns for the x and y coordinates.");
 
+      Encoding.Length = data.Dimension;
       Name = data.Name;
       Description = data.Description;
@@ -97,14 +121,14 @@
         switch (data.DistanceMeasure) {
           case DistanceMeasure.Euclidean:
-            throw new NotImplementedException();
+            TSPData = new EuclideanTSPData(data.Coordinates) { Rounding = EuclideanTSPData.RoundingMode.None };
             break;
           case DistanceMeasure.RoundedEuclidean:
-            TSPData = new RoundedEuclideanCoordinatesTSPData(data.Coordinates);
+            TSPData = new EuclideanTSPData(data.Coordinates) { Rounding = EuclideanTSPData.RoundingMode.Midpoint };
             break;
           case DistanceMeasure.UpperEuclidean:
-            throw new NotImplementedException();
+            TSPData = new EuclideanTSPData(data.Coordinates) { Rounding = EuclideanTSPData.RoundingMode.Ceiling };
             break;
           case DistanceMeasure.Geo:
-            throw new NotImplementedException();
+            TSPData = new GeoTSPData(data.Coordinates);
             break;
           default:
@@ -128,4 +152,58 @@
       OnReset();
     }
+
+    protected override void OnEncodingChanged() {
+      base.OnEncodingChanged();
+      ParameterizeOperators();
+    }
+
+    protected override void OnEvaluatorChanged() {
+      base.OnEvaluatorChanged();
+      ParameterizeOperators();
+    }
+
+    private void InitializeOperators() {
+      Operators.Add(new TSPImprovementOperator());
+      Operators.Add(new TSPMultipleGuidesPathRelinker());
+      Operators.Add(new TSPPathRelinker());
+      Operators.Add(new TSPSimultaneousPathRelinker());
+
+      Operators.Add(new TSPAlleleFrequencyAnalyzer());
+      foreach (var op in ApplicationManager.Manager.GetInstances<ITSPMoveEvaluator>())
+        Operators.Add(op);
+
+      ParameterizeOperators();
+    }
+
+    private void ParameterizeOperators() {
+      foreach (var op in Operators.OfType<TSPAlleleFrequencyAnalyzer>()) {
+        op.MaximizationParameter.ActualName = MaximizationParameter.Name;
+        op.TSPDataParameter.ActualName = TSPDataParameter.Name;
+        op.SolutionParameter.ActualName = Encoding.Name;
+        op.QualityParameter.ActualName = Evaluator.QualityParameter.ActualName;
+        op.BestKnownSolutionParameter.ActualName = BestKnownSolutionParameter.Name;
+        op.ResultsParameter.ActualName = "Results";
+      }
+      foreach (var op in Operators.OfType<ITSPMoveEvaluator>()) {
+        op.TSPDataParameter.ActualName = TSPDataParameter.Name;
+        op.TSPDataParameter.Hidden = true;
+        op.TourLengthParameter.ActualName = Evaluator.QualityParameter.ActualName;
+        op.TourLengthParameter.Hidden = true;
+        op.TSPTourParameter.ActualName = Encoding.Name;
+        op.TSPTourParameter.Hidden = true;
+      }
+      foreach (var op in Operators.OfType<ISingleObjectiveImprovementOperator>()) {
+        op.SolutionParameter.ActualName = Encoding.Name;
+        op.SolutionParameter.Hidden = true;
+      }
+      foreach (ISingleObjectivePathRelinker op in Operators.OfType<ISingleObjectivePathRelinker>()) {
+        op.ParentsParameter.ActualName = Encoding.Name;
+        op.ParentsParameter.Hidden = true;
+      }
+      foreach (ISolutionSimilarityCalculator op in Operators.OfType<ISolutionSimilarityCalculator>()) {
+        op.SolutionVariableName = Encoding.Name;
+        op.QualityVariableName = Evaluator.QualityParameter.ActualName;
+      }
+    }
   }
 }
Index: /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/TSPData.cs
===================================================================
--- /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/TSPData.cs	(revision 17240)
+++ /branches/2521_ProblemRefactoring/HeuristicLab.Problems.TravelingSalesman/3.3/TSPData.cs	(revision 17241)
@@ -1,7 +1,10 @@
 ﻿using System;
+using System.ComponentModel;
+using System.Drawing;
 using HEAL.Attic;
 using HeuristicLab.Common;
 using HeuristicLab.Core;
 using HeuristicLab.Data;
+using HeuristicLab.Encodings.PermutationEncoding;
 
 namespace HeuristicLab.Problems.TravelingSalesman {
@@ -9,51 +12,12 @@
   public interface ITSPData : IItem {
     double GetDistance(int fromCity, int toCity);
-  }
-
-  [Item("Coordinates-based TSP Data", "TSP that is represented by coordinates of cities.")]
-  [StorableType("3955d07a-d43c-4a01-9505-d2effb1ea865")]
-  public abstract class CoordinatesTSPData : Item, ITSPData {
-    [Storable]
-    public DoubleMatrix Coordinates { get; set; }
-
-    [StorableConstructor]
-    protected CoordinatesTSPData(StorableConstructorFlag _) : base(_) { }
-    protected CoordinatesTSPData(CoordinatesTSPData original, Cloner cloner) : base(original, cloner) {
-      Coordinates = cloner.Clone(original.Coordinates);
-    }
-    protected CoordinatesTSPData() : base() {
-      Coordinates = new DoubleMatrix();
-    }
-    protected CoordinatesTSPData(double[,] coordinates) : base() {
-      if (coordinates == null) throw new ArgumentNullException(nameof(coordinates));
-      if (coordinates.GetLength(1) != 2) throw new ArgumentException("Argument must have exactly two columns.", nameof(coordinates));
-      Coordinates = new DoubleMatrix(coordinates);
-    }
-
-    public double GetDistance(int fromCity, int toCity) {
-      return GetDistance(Coordinates[fromCity, 0], Coordinates[fromCity, 1],
-        Coordinates[toCity, 0], Coordinates[toCity, 1]);
-    }
-
-    public abstract double GetDistance(double fromX, double fromY, double toX, double toY);
-  }
-
-  [Item("Euclidean (rounded) TSP Data", "TSP that is represented by coordinates and a rounded euclidean distance measure.")]
-  [StorableType("4bf58348-cd98-46c5-a4c0-55f486ca88b4")]
-  public sealed class RoundedEuclideanCoordinatesTSPData : CoordinatesTSPData {
-
-    [StorableConstructor]
-    private RoundedEuclideanCoordinatesTSPData(StorableConstructorFlag _) : base(_) { }
-    private RoundedEuclideanCoordinatesTSPData(RoundedEuclideanCoordinatesTSPData original, Cloner cloner) : base(original, cloner) { }
-    public RoundedEuclideanCoordinatesTSPData() : base() { }
-    public RoundedEuclideanCoordinatesTSPData(double[,] coordinates) : base(coordinates) { }
-
-    public override IDeepCloneable Clone(Cloner cloner) {
-      return new RoundedEuclideanCoordinatesTSPData(this, cloner);
-    }
-
-    public override double GetDistance(double fromX, double fromY, double toX, double toY) {
-      return Math.Round(Math.Sqrt((fromX - toX) * (fromX - toX) + (fromY - toY) * (fromY - toY)));
-    }
+    ITSPSolution GetSolution(Permutation tspTour, double tourLength);
+  }
+
+  [StorableType("f08a63d9-0b83-4944-9251-42925baeb872")]
+  public interface ITSPSolution : IItem {
+    DoubleMatrix Coordinates { get; }
+    Permutation Tour { get; }
+    DoubleValue TourLength { get; }
   }
 
@@ -84,4 +48,8 @@
       if (DisplayCoordinates != null && DisplayCoordinates.Rows != Matrix.GetLength(0))
         throw new ArgumentException("Unequal number of rows in " + nameof(matrix) + " and " + nameof(coordinates) + ".");
+    }
+
+    public ITSPSolution GetSolution(Permutation tour, double tourLength) {
+      return new PathTSPTour(DisplayCoordinates, tour, new DoubleValue(tourLength));
     }
 
@@ -111,3 +79,181 @@
     public double GetDistance(int fromCity, int toCity) => Matrix[fromCity, toCity];
   }
+
+  [Item("Coordinates-based TSP Data", "TSP that is represented by coordinates of locations.")]
+  [StorableType("3955d07a-d43c-4a01-9505-d2effb1ea865")]
+  public abstract class CoordinatesTSPData : Item, ITSPData {
+    [Storable]
+    public DoubleMatrix Coordinates { get; set; }
+
+    [StorableConstructor]
+    protected CoordinatesTSPData(StorableConstructorFlag _) : base(_) { }
+    protected CoordinatesTSPData(CoordinatesTSPData original, Cloner cloner) : base(original, cloner) {
+      Coordinates = cloner.Clone(original.Coordinates);
+    }
+    protected CoordinatesTSPData() : base() {
+      Coordinates = new DoubleMatrix();
+    }
+    protected CoordinatesTSPData(double[,] coordinates) : base() {
+      if (coordinates == null) throw new ArgumentNullException(nameof(coordinates));
+      if (coordinates.GetLength(1) != 2) throw new ArgumentException("Argument must have exactly two columns.", nameof(coordinates));
+      Coordinates = new DoubleMatrix(coordinates);
+    }
+
+    public double GetDistance(int fromCity, int toCity) {
+      return GetDistance(Coordinates[fromCity, 0], Coordinates[fromCity, 1],
+        Coordinates[toCity, 0], Coordinates[toCity, 1]);
+    }
+
+    public abstract double GetDistance(double fromX, double fromY, double toX, double toY);
+
+    public ITSPSolution GetSolution(Permutation tour, double tourLength) {
+      return new PathTSPTour(Coordinates, tour, new DoubleValue(tourLength));
+    }
+  }
+
+  [Item("Euclidean TSP Data", "TSP that is represented by coordinates in an Euclidean plane.")]
+  [StorableType("4bf58348-cd98-46c5-a4c0-55f486ca88b4")]
+  public sealed class EuclideanTSPData : CoordinatesTSPData {
+    public enum RoundingMode { None, Midpoint, Ceiling }
+
+    [Storable]
+    public RoundingMode Rounding { get; set; }
+
+    [StorableConstructor]
+    private EuclideanTSPData(StorableConstructorFlag _) : base(_) { }
+    private EuclideanTSPData(EuclideanTSPData original, Cloner cloner) : base(original, cloner) {
+      Rounding = original.Rounding;
+    }
+    public EuclideanTSPData() : base() { }
+    public EuclideanTSPData(double[,] coordinates) : base(coordinates) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new EuclideanTSPData(this, cloner);
+    }
+
+    public override double GetDistance(double fromX, double fromY, double toX, double toY) {
+      var dist = Math.Sqrt((fromX - toX) * (fromX - toX) + (fromY - toY) * (fromY - toY));
+      switch (Rounding) {
+        case RoundingMode.None: return dist;
+        case RoundingMode.Midpoint: return Math.Round(dist);
+        case RoundingMode.Ceiling: return Math.Ceiling(dist);
+        default: throw new InvalidOperationException("Unknown rounding mode " + Rounding);
+      }
+    }
+  }
+
+  [Item("Geo TSP Data", "TSP that is represented by geo coordinates.")]
+  [StorableType("4bf58348-cd98-46c5-a4c0-55f486ca88b4")]
+  public sealed class GeoTSPData : CoordinatesTSPData {
+    public const double PI = 3.141592;
+    public const double RADIUS = 6378.388;
+
+    [StorableConstructor]
+    private GeoTSPData(StorableConstructorFlag _) : base(_) { }
+    private GeoTSPData(GeoTSPData original, Cloner cloner) : base(original, cloner) { }
+    public GeoTSPData() : base() { }
+    public GeoTSPData(double[,] coordinates) : base(coordinates) { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new GeoTSPData(this, cloner);
+    }
+
+    public override double GetDistance(double fromX, double fromY, double toX, double toY) {
+      double latitude1, longitude1, latitude2, longitude2;
+      double q1, q2, q3;
+      double length;
+
+      latitude1 = ConvertToRadian(fromX);
+      longitude1 = ConvertToRadian(fromY);
+      latitude2 = ConvertToRadian(toX);
+      longitude2 = ConvertToRadian(toY);
+
+      q1 = Math.Cos(longitude1 - longitude2);
+      q2 = Math.Cos(latitude1 - latitude2);
+      q3 = Math.Cos(latitude1 + latitude2);
+
+      length = (int)(RADIUS * Math.Acos(0.5 * ((1.0 + q1) * q2 - (1.0 - q1) * q3)) + 1.0);
+      return (length);
+    }
+
+    private double ConvertToRadian(double x) {
+      return PI * (Math.Truncate(x) + 5.0 * (x - Math.Truncate(x)) / 3.0) / 180.0;
+    }
+  }
+  /// <summary>
+  /// Represents a tour of a Traveling Salesman Problem given in path representation which can be visualized in the GUI.
+  /// </summary>
+  [Item("PathTSPTour", "Represents a tour of a Traveling Salesman Problem given in path representation which can be visualized in the GUI.")]
+  [StorableType("2CAE7C49-751B-4802-9025-62E2268E47AE")]
+  public sealed class PathTSPTour : Item, ITSPSolution, INotifyPropertyChanged {
+    public static new Image StaticItemImage {
+      get { return HeuristicLab.Common.Resources.VSImageLibrary.Image; }
+    }
+
+    [Storable]
+    private DoubleMatrix coordinates;
+    public DoubleMatrix Coordinates {
+      get { return coordinates; }
+      set {
+        if (coordinates == value) return;
+        coordinates = value;
+        OnPropertyChanged(nameof(Coordinates));
+      }
+    }
+
+    [Storable(Name = "tour", OldName = "permutation")]
+    private Permutation tour;
+    public Permutation Tour {
+      get { return tour; }
+      set {
+        if (tour == value) return;
+        tour = value;
+        OnPropertyChanged(nameof(Tour));
+      }
+    }
+    [Storable(Name = "tourLength", OldName = "quality")]
+    private DoubleValue tourLength;
+    public DoubleValue TourLength {
+      get { return tourLength; }
+      set {
+        if (tourLength == value) return;
+        tourLength = value;
+        OnPropertyChanged(nameof(TourLength));
+      }
+    }
+
+    [StorableConstructor]
+    private PathTSPTour(StorableConstructorFlag _) : base(_) { }
+    private PathTSPTour(PathTSPTour original, Cloner cloner)
+      : base(original, cloner) {
+      this.coordinates = cloner.Clone(original.coordinates);
+      this.tour = cloner.Clone(original.tour);
+      this.tourLength = cloner.Clone(original.tourLength);
+    }
+    public PathTSPTour() : base() { }
+    public PathTSPTour(DoubleMatrix coordinates)
+      : base() {
+      this.coordinates = coordinates;
+    }
+    public PathTSPTour(DoubleMatrix coordinates, Permutation permutation)
+      : base() {
+      this.coordinates = coordinates;
+      this.tour = permutation;
+    }
+    public PathTSPTour(DoubleMatrix coordinates, Permutation permutation, DoubleValue quality)
+      : base() {
+      this.coordinates = coordinates;
+      this.tour = permutation;
+      this.tourLength = quality;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new PathTSPTour(this, cloner);
+    }
+
+    public event PropertyChangedEventHandler PropertyChanged;
+    private void OnPropertyChanged(string property) {
+      PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(property));
+    }
+  }
 }
